#ifndef ASSYM_HPP_
#define ASSYM_HPP_
#define assym_hpp_version "$Revision: 1.4 $"

#include "GlobalSettings.hpp"
#include <algorithm>
#include "Watching.hpp"
#include "IFStream.hpp"
#include "Hash.hpp"
#include "VariableInfos.hpp"
#include "ClauseInfos.hpp"
#include "SimplyFire.hpp"
#include "BCPEngine.hpp"


using std::pair;

//dynamic would be better
#define ASSYM_HYPER_BIN 1



class Assym{

	typedef uint64_t levl_t;
	struct VInf{
		levl_t reasn;
		levl_t root;
	};

	SolvState<SimplyFire,LeaderSiblingInfo>& sstate;
	BitVector<Variable>& 	var_flgs;
	vector<Literal>&		units_out;

protected:
	//BinCrossSum								count_ones;
	VInf* vInfP(const Variable& v){asrt(v.idx() * 2 < sstate.cls_reg.lit_space.size());
		return  (VInf*) &(sstate.cls_reg.lit_space[v.idx() << 1]);}
	VInf* vInfP(const Literal& l){return vInfP(l.toVar());}

	vector<Literal>			ass_stck;



	//const   var_act_t					hbin_over;
	vector<std::pair<Literal,ClsBin> > 	prop_touched;
	vector<ClsPointer >					prop_confl;
	uint32_t 							confl_strt;
	BinCrossSum							count_ones;

	void foundSubsumd(const ClsPointer& subsumed, const ClsPointer& by);


	enum Task{TAKE_MRKD,LEAVE,GO,NEWVERSION};

	//void cleanClsDB();
	//bool bcpAt0(Literal lit);
	Task propLongs(const Literal* lits);
	//void collStrongReasons(const ClsWrp& clw, const Literal& w, levl_t& sr,levl_t& roots);
	void collReasons(SharedClause* cls, const Literal& except_w, levl_t& reason, levl_t& root);
	uint32_t collRsnsCountMrkd(SharedClause* cls, levl_t& reason, levl_t& root);
	bool enqBcpBin(Literal lit, const levl_t& reason, const levl_t& root);
	void enqueue(const Literal& l,const levl_t& reason, const levl_t& root){ asrt(sstate.vals.litUkwn(l));
		LOG2("Enqueue lit " << l.toDIMACS() << " with reason " << reason << " and root " << root);
		VInf* vinf		= vInfP(l);
		vinf->reasn		= reason;
		vinf->root		= root;
		sstate.vals		.setValue(l);	asrt(!var_flgs.isSet(l.toVar())||powOf2(reason));
		ass_stck.push_back(l);}


	void undoAssCompl();
	void undoAss();

	//shrinkyWinky helpers
	bool	getAltReason(const Literal& l, const ClsBin& clw,levl_t& reas_out, levl_t& root_out);
	void 	updateAllReasons(const Literal* lits, const uint32_t& end, const levl_t old, const levl_t repl);
	Task 	smpleChk(uint32_t& mrkd_c,const Literal* lits,const uint32_t& end);


	Task 	handleConflictingFor(const ClsPointer& orig,Literal* lits, uint32_t& end, uint32_t& mrkd, levl_t& all_levs);
	Task 	propFlippedLits(Literal* lits, uint32_t& sz, const ClsPointer& clp);
	//bool	recomputeReasons();
	Task	enqFlippedLits(Literal* lits, uint32_t& sz, levl_t& all_lvls, const ClsPointer& orig);
	//Task	reEnqFlippedLits(Literal* lits, uint32_t& sz, levl_t& all_lvls);

	void clearProp();

	void	addBins(const Literal& lit, levl_t roots, const Literal* lits);
	void	addBins(const Literal& lit, VInf* ai, levl_t roots, const Literal* lits);


public:
	void clear(){clearProp();}

	void	setReasonForFix(const Literal& l){VInf* li = vInfP(l); li->reasn=0; li->root=0;}
	uint32_t shrinkyWinky(const ClsPointer& orig);
	//void justHpyerBin(const Literal& root);

	Assym(SolvState<SimplyFire,LeaderSiblingInfo>& state, BitVector<Variable>& flgs,vector<Literal>& unitsout):
		sstate(state),var_flgs(flgs),units_out(unitsout),confl_strt(0){}

	friend class Settings;
};

const char*  assym_cpp_version();
#endif /* ASSYM_HPP_ */
